<?php session_start();
date_default_timezone_set('America/Bogota');
//RESTRICCI�N DE ACCESO A TRABAJADOR (ACCESO INDIVIDUAL)
if (isset($_SESSION['tipousuario']))
		{if ($_SESSION['tipousuario']=='1')
		header ('location:menu_personal.php');
		}
if  (trim($_SESSION['nombre_validar'])=='') header ('location:index.php');
include ("fphp.php");
$enlace=cargar_conexion();
$consulta=mysql_query("select * from periodo where id='".$_SESSION['id_validar']."' order by nomina,periodo desc limit 1");
if (mysql_num_rows($consulta)!=0){
	$row=mysql_fetch_array($consulta);
	$_SESSION['per_validar']=mostrar_fecha($row['desde']).' al '.mostrar_fecha($row['hasta'])." (Nom:".$row['nomina'].")";
} else $_SESSION['per_validar']='';
menu();


echo "<font face='verdana' size=2>";

if(isset($_POST['generarBanco'])){
  //----------------VARIABLES PARA LA CABECERA------------------------//

  //--Se define el periodo que se esta trabajando
  $periodo = $_POST['periodo'];
  $periodo = explode(' ',$periodo);
  $desde = date('Y-m-d',strtotime($periodo[0]));
  $hasta = date('Y-m-d',strtotime($periodo[1]));
	$desperiodo = $desde." al ".$hasta;
	$tipo_nomina_post = $_POST['tipo_nomina'];

  //------------------------------//
  //-----Se declara variables para uso despues
  $n = null;
  $n_alterno = null;
  //-------Año actual
  $year = date('y');
  $type = null;
  //---Si la nomina es normal, de contingencia o de fideicomiso, el tipo es 1
  if($_POST['nomina'] == 'nomina_contingencia' || $_POST['nomina'] == 'nomina_normal' ){
      $type = 1;
  }else if( $_POST['nomina'] == 'nomina_fideicomiso'){
      $type = 5;
  }
  //--- Se declara la fecha y a partir de alli se busca el ultimo dia vigente
  $semanainicio = date("W",strtotime($desde))+2;
  $semanafin = date("W",strtotime($hasta))+2;


  //---- Fecha actual acomodada para txt
  $dateNow = date('Y-m-d');
  $dateNow = explode("-",$dateNow);
  $dateNow = $dateNow[0]."".$dateNow[1]."".$dateNow[2];

  // A partir del tipo de nomina, se declara un autoincrementable
  if($_POST['tipo_nomina'] == '100'){
      $n = 2;
      $n_alterno = 21;

  }else if($_POST['tipo_nomina']=='200'){
      $n = 1;
      $n_alterno = 11;
  }
  //Se cuadran las fecha y se buscan los dias habiles para tomar el ultimo que servira como pago
  $desdeI = strtotime($desde);
  $hastaF = strtotime($hasta);
  // echo $desdeI."<br>";
  // echo $hastaF."<br>";
  $diainc = 24*60*60;
  $diashabiles = [];
  for ($midia = $desdeI; $midia <= $hastaF; $midia += $diainc) {
          if (!in_array(date('N', $midia), array(6,7))) {
              array_push($diashabiles, date('Y-m-d', $midia));
          }
  }

  $fecha_tramite = [];
  // var_dump($diashabiles);
  $tipo_nomina = null;
  // A partir del tipo de contingencia, se toma la fecha y se le agrega los dias que serviran para el pago a efectuar



  // echo $fecha_tramite;
  // Recolecto el listado de cedulas correspondientes al periodo vigente
  $query = "SELECT DISTINCT cedula as cedula FROM `historico`";
  $resultado = mysql_query($query);
  $cedulas = [];
  while($datesCodes = mysql_fetch_array($resultado)){
      $cedulas[] = $datesCodes['cedula'];
  }
  $sum = null;
  $res = null;

  // Se realiza la sumatoria total del monto de los empleados en general
  foreach ($cedulas as $c) {
      $query2 = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'A'";
      $resultado = mysql_query($query2);
      while ($sumatoria = mysql_fetch_array($resultado)) {
          $sum += $sumatoria['monto'];
      }
  }
  foreach ($cedulas as $c) {
      $query2 = "SELECT SUM(monto) as monto FROM `historico` WHERE cedula = '$c' AND tipo = 'D'";
      $resultado = mysql_query($query2);
      while ($sumatoria = mysql_fetch_array($resultado)) {
          $res += $sumatoria['monto'];
      }
  }
  $monto_a_pagar = $sum-$res;
  $monto_a_pagar = intval($monto_a_pagar);


  //-------------CREACIÓN DE EL ARCHIVO DE CONTINGENCIA //////////

  if($_POST['nomina'] == 'nomina_contingencia'){

    $tipo_nomina = "CONTING0";
    $zipNombre = 'nominasCont.zip';
    $zip = new ZipArchive();
    $zip->open($zipNombre, ZipArchive::CREATE);

    $contador = 1;
    $autoIncremental=3;
    for($i=0 ; $i < 3 ; $i++){

        //Construyo la fecha a pagar la nomina para los 3 archivos
        switch ($i) {
            case 0:
                $fecha_pagar_nomina = date('Y-m-d',strtotime($hasta."+ 1 week"));
                $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."+ 5 days"));
                break;
            case 1:
                $fecha_pagar_nomina = date('Y-m-d',strtotime($hasta."+ 2 week"));
                $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."+ 5 days"));
                break;
            case 2:
                $fecha_pagar_nomina = date('Y-m-d',strtotime($hasta."+ 3 week"));
                $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."+ 5 days"));
                break;
        }

        //Consulto los festivos existentes
        $queryFestivos = "SELECT `fecha` FROM tab_feriado";
        $resultFestivos = mysql_query($queryFestivos);
        $arrayFestivos = [];

        //Construyo array con los festivos existentes
        while($datosFestivos = mysql_fetch_array($resultFestivos)){
            $datoFestivo = date('m-d',strtotime($datosFestivos['fecha']));
            $arrayFestivos[] = $datoFestivo;
        }

        //Verifico si la fecha a pagar es festivo
        for($iFes=0;$iFes < count($arrayFestivos);$iFes++){
            $verificar_festivo = date('m-d',strtotime($fecha_pagar_nomina));
            if($verificar_festivo == $arrayFestivos[$iFes]){
                $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."- 1 days"));
                $iFes=0;
            }
        }

        //Se le quita los guiones
        $fecha_pagar_nomina_array = explode("-",$fecha_pagar_nomina);

        //Unir todos los datos para imprimir
        $fecha_pagar_nomina = $fecha_pagar_nomina_array[0]."".$fecha_pagar_nomina_array[1]."".$fecha_pagar_nomina_array[2];

        $nombre_archivo = "nomina_semana".$semanainicio."_".$autoIncremental.".txt";
        $file = fopen($nombre_archivo,"w+");


        //----------------------------HEADER--------------//
        fwrite($file,"HDR");
        fwrite($file,"UNIOVECA       ED  95BPAYMULP");
        fwrite($file,"\n");
        fwrite($file,"01");
        fwrite($file,$tipo_nomina);
        fwrite($file,$n);
        fwrite($file,$year);
        fwrite($file,$type);
        fwrite($file,$autoIncremental); // Aquí va el auto incremento
        fwrite($file,$semanainicio);
        fwrite($file,"9");
        fwrite($file,"  ");
        fwrite($file,$dateNow);
        fwrite($file,"SALJ000148643");
        fwrite($file,"       FORD MOTOR VENEZUELA S.A.");
        fwrite($file,"\n");
        fwrite($file,"02");
        fwrite($file,$fecha_pagar_nomina);
        fwrite($file,"0".$n);
        fwrite($file,$year);
        fwrite($file,$type);
        fwrite($file,$autoIncremental);
        $autoIncremental = $autoIncremental -1;
        fwrite($file,$semanainicio);
        $semanainicio= $semanainicio + 1;
        fwrite($file,"               ");
        $sumaMontoTotal = 0;

        foreach ($cedulas as $c){
            //-----MONTO TIPO A
            $queryA = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH' AND tipo = 'A' AND concepto != '5008' and concepto != '5009'";
            $resultadoA = mysql_query($queryA);

            while ( $sumatoriaA = mysql_fetch_array($resultadoA)) {
                $empleadoA = $sumatoriaA['monto'];
            }
            //-----MONTO TIPO D
            $queryD = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH' AND tipo = 'D' AND concepto != '6000' and concepto != '6001'";
            $resultadoD = mysql_query($queryD);

            while ($sumatoriaD = mysql_fetch_array($resultadoD)) {
                $empleadoD = $sumatoriaD['monto'];
            }

            $montoEmpleado =  $empleadoA - $empleadoD;
            $montoEmpleado = number_format($montoEmpleado, 2);
            $montoEmpleado =  str_replace(',','',$montoEmpleado);
            $montoEmpleado =  str_replace('.','',$montoEmpleado);
            $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;
        }
        $num_sumaMontoTotal = strlen($sumaMontoTotal);
        while($num_sumaMontoTotal<17){
            fwrite($file,"0");
            $num_sumaMontoTotal++;
        }
        fwrite($file,$sumaMontoTotal);
        fwrite($file,"VES");
        fwrite($file,"01340968419683001284               UNIOVECA");
        fwrite($file,"\n");
        $sumaMontoTotal = 0;

        // ordenar por ultimmo
        //--------------------------------------------------//
        //-------------------------BODY----------------------//
        foreach ($cedulas as $c) {
            fwrite($file,"03");
            fwrite($file,"9  ");

            //-----MONTO TIPO A
            $queryA = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH' AND tipo = 'A' AND concepto != '5008' and concepto != '5009'";
            $resultadoA = mysql_query($queryA);

            while ( $sumatoriaA = mysql_fetch_array($resultadoA)) {
                $empleadoA = $sumatoriaA['monto'];
            }
            //-----MONTO TIPO D
            $queryD = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH' AND tipo = 'D' AND concepto != '6000' and concepto != '6001'";
            $resultadoD = mysql_query($queryD);

            while ($sumatoriaD = mysql_fetch_array($resultadoD)) {
                $empleadoD = $sumatoriaD['monto'];
            }

            $montoEmpleado =  $empleadoA - $empleadoD;
            $montoEmpleado = number_format($montoEmpleado, 2);
            $montoEmpleado =  str_replace(',','',$montoEmpleado);
            $montoEmpleado =  str_replace('.','',$montoEmpleado);
            $num_montoEmpleado = strlen($montoEmpleado);
            while($num_montoEmpleado<17){
                fwrite($file,"0");
                $num_montoEmpleado++;
            }
            fwrite($file,$montoEmpleado);
            fwrite($file,"VES01");
            fwrite($file,$n_alterno);
            $query3 = "SELECT * FROM `personal` WHERE codigo = '$c'";
            $resultado = mysql_query($query3);
            $datos_empleado = mysql_fetch_array($resultado);
            fwrite($file,substr($datos_empleado['global_id'],-4));
            fwrite($file,"          ");
            fwrite($file,"42    ");
            fwrite($file,$datos_empleado['cuenta']);
            fwrite($file,"               UNIOVECA         ");
            fwrite($file,$datos_empleado['nacionalidad']);
            fwrite($file,"00".$datos_empleado['codigo']);
            fwrite($file,"                                                                                                               ");
            if($datos_empleado['apellidos1'] == null){
                fwrite($file,$datos_empleado['apellidos']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1']);
            }else{
                fwrite($file,$datos_empleado['apellidos']." ".$datos_empleado['apellidos1']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1']);
            }
            fwrite($file,"\n");
            $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;
        }

        //---------------------------------------------------//
        //-------------FOOTER--------------------------------//
        fwrite($file,"06");
        fwrite($file,"000000000000001");
        $num_cedulas = strlen(count($cedulas));
        while($num_cedulas<15){
            fwrite($file,"0");
            $num_cedulas++;
        }
        fwrite($file,count($cedulas));
        $num_sumaMontoTotal = strlen($sumaMontoTotal);
        while($num_sumaMontoTotal<17){
            fwrite($file,"0");
            $num_sumaMontoTotal++;
        }
        fwrite($file,$sumaMontoTotal);
        //---------------------------------------------------//
        fclose($file);

        $contador++;

        $zip->addFile($nombre_archivo);


    }


    $zip->close();
    echo "<style>
    .regristrado{
        color: green;
        margin-left: 7%;
        font-weight: bold;
    }
    </style>";
    echo "<p class='regristrado'>Archivo guardado correctamente<p>";

    echo "<script>
        window.location.href = 'generar_txt.php?fileBankZip=$zipNombre';
        </script>";






















  }else if ($_POST['nomina'] == 'nomina_normal'){

    //-------------CREACIÓN DE EL ARCHIVO  DE NORMAL /////////

		// Recolecto el listado de cedulas correspondientes al periodo vigente
	  //$query = "SELECT DISTINCT cedula FROM `historico` WHERE id='".$_SESSION['id_validar']."' AND desperiodo ='$desperiodo' AND nomina = '$tipo_nomina_post'";
		$query = "SELECT DISTINCT cedula FROM `historico` WHERE cedula = '16579794' AND id='".$_SESSION['id_validar']."' AND desperiodo ='$desperiodo' AND nomina = '$tipo_nomina_post'";

	  $resultado = mysql_query($query);
	  $cedulas = [];
	  while($datesCodes = mysql_fetch_array($resultado)){
	      $cedulas[] = $datesCodes['cedula'];
	  }

    $tipo_nomina = "99999990";
    $fecha_tramite = end($diashabiles);
    $fecha_pagar_nomina = date('Y-m-d',strtotime($hasta."+ 4 days"));

    //Consulto los festivos existentes
    $queryFestivos = "SELECT `fecha` FROM tab_feriado";
    $resultFestivos = mysql_query($queryFestivos);
    $arrayFestivos = [];

    //Construyo array con los festivos existentes
    while($datosFestivos = mysql_fetch_array($resultFestivos)){
        $datoFestivo = date('m-d',strtotime($datosFestivos['fecha']));
        $arrayFestivos[] = $datoFestivo;
    }

    //Verifico si la fecha a pagar es festivo
    for($iFes=0;$iFes < count($arrayFestivos);$iFes++){
        $verificar_festivo = date('m-d',strtotime($fecha_pagar_nomina));
        if($verificar_festivo == $arrayFestivos[$iFes]){
            $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."- 1 days"));
            $iFes=0;
        }
    }

    //Se le quita los guiones
    $fecha_pagar_nomina_array = explode("-",$fecha_pagar_nomina);

    //Unir todos los datos para imprimir
    $fecha_pagar_nomina = $fecha_pagar_nomina_array[0]."".$fecha_pagar_nomina_array[1]."".$fecha_pagar_nomina_array[2];

		$fecha_pagar_nomina = '20210830';
    //Define la semana de este periodo
    $semanainicio = $semanainicio -1;
    //-------------------------------------------------//
    $nombre_archivo = "nomina.txt";
    $file = fopen($nombre_archivo,"w+");

    //----------------------------HEADER--------------//
    fwrite($file,"HDR");
    fwrite($file,"UNIOVECA       ED  95BPAYMULP");
		fwrite($file,str_pad("", 261, " ", STR_PAD_RIGHT)); //Imprime espacios

    fwrite($file,"\r\n"); //Nueva Linea
    fwrite($file,"01"); //Tipo de registro
    fwrite($file,$tipo_nomina); //Constante
    fwrite($file,$n); //2 Si es tipo de nomina 100, 1 Si es 200
    fwrite($file,$year); //Año actual
		fwrite($file,$type); //1  -> TIPO DE PROCESO: (NORMAL: 1, FIDEICOMISO: 5, VACACIONES: 3, UTILIDADES: 4), NÓMINA DE CONTINGENCIA ES NORMAL.
		fwrite($file,"A"); //Autoincremental, por el momento se deja en cero.
    fwrite($file,$semanainicio); //Número de la semana correspondiente al periodo a generar
    fwrite($file,"9  "); //Constante
    fwrite($file,$dateNow);//Fecha en que se genera el archivo
    fwrite($file,"SALJ000148643       FORD MOTOR VENEZUELA S.A."); //Constante
		fwrite($file,str_pad("", 220, " ", STR_PAD_RIGHT)); //Imprime espacios
    fwrite($file,"\r\n"); //Nueva Linea
		fwrite($file,"02"); //Tipo de registro - Constante
		fwrite($file,$fecha_pagar_nomina); //Fecha en la que se debe pagar la nomina
    fwrite($file,"0".$n);//2 Si es tipo de nomina 100, 1 Si es 200
		fwrite($file,$year);
    fwrite($file,$type);
    fwrite($file,"A");
    fwrite($file,$semanainicio);
		fwrite($file,"               ");

    $sumaMontoTotal = 0;
    foreach ($cedulas as $c){
        //-----MONTO TIPO A
        $queryA = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `desperiodo` = '$desperiodo' AND tipo = 'A' AND nomina = '$tipo_nomina_post' AND concepto != '5008' and concepto != '5009'";
        $resultadoA = mysql_query($queryA);

        while ( $sumatoriaA = mysql_fetch_array($resultadoA)) {
            $empleadoA = $sumatoriaA['monto'];
        }
        //-----MONTO TIPO D
        $queryD = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `desperiodo` LIKE '$desperiodo' AND tipo = 'D' AND nomina = '$tipo_nomina_post' AND concepto != '6000' and concepto != '6001'";
        $resultadoD = mysql_query($queryD);

        while ($sumatoriaD = mysql_fetch_array($resultadoD)) {
            $empleadoD = $sumatoriaD['monto'];
        }

        $montoEmpleado =  $empleadoA - $empleadoD;

				$montoEmpleado = '1.00';

        $montoEmpleado = number_format($montoEmpleado, 2);
        $montoEmpleado =  str_replace(',','',$montoEmpleado);
        $montoEmpleado =  str_replace('.','',$montoEmpleado);
        $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;



    }

		fwrite($file,str_pad($sumaMontoTotal, 17, "0", STR_PAD_LEFT)); //Día sin cero a la izq
    fwrite($file,"VES01340968419683001284               UNIOVECA"); //Constante
		fwrite($file,str_pad("", 197, " ", STR_PAD_RIGHT)); //Imprime espacios
    fwrite($file,"\r\n"); //Nueva Linea
    $sumaMontoTotal = 0;

    //--------------------------------------------------//
    //-------------------------BODY----------------------//
    foreach ($cedulas as $c) {
      fwrite($file,"03"); //Constante
      fwrite($file,"9  ");//Constante

      //-----MONTO TIPO A
      $queryA = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `desperiodo` LIKE '$desperiodo' AND tipo = 'A' AND nomina = '$tipo_nomina_post' AND concepto != '5008' and concepto != '5009'";
      $resultadoA = mysql_query($queryA);

      while ( $sumatoriaA = mysql_fetch_array($resultadoA)) {
          $empleadoA = $sumatoriaA['monto'];
      }
      //-----MONTO TIPO D
      $queryD = "SELECT SUM(monto) as monto FROM `historico` WHERE `cedula` LIKE '$c' AND `desperiodo` LIKE '$desperiodo' AND tipo = 'D' AND nomina = '$tipo_nomina_post' AND concepto != '6000' and concepto != '6001'";
      $resultadoD = mysql_query($queryD);

      while ($sumatoriaD = mysql_fetch_array($resultadoD)) {
          $empleadoD = $sumatoriaD['monto'];
      }

      $montoEmpleado =  $empleadoA - $empleadoD;

			$montoEmpleado = '1.00';

      $montoEmpleado =  number_format($montoEmpleado, 2);
      $montoEmpleado =  str_replace(',','',$montoEmpleado);
      $montoEmpleado =  str_replace('.','',$montoEmpleado);

			fwrite($file,str_pad($montoEmpleado, 17, "0", STR_PAD_LEFT)); //Día sin cero a la izq
      fwrite($file,"VES01"); //Constante
      fwrite($file,$n_alterno); //11 -> MENSUAL, PARA DIARIA ES (21)
      $query3 = "SELECT * FROM `personal` WHERE codigo = '$c'";
      $resultado = mysql_query($query3);
      $datos_empleado = mysql_fetch_array($resultado);
      fwrite($file,substr($datos_empleado['global_id'],-4)); //Ultimos 4 digitos del Global ID
      fwrite($file,"          42    "); //Constante
      fwrite($file,$datos_empleado['cuenta']); //Numero de cuenta
      fwrite($file,"               UNIOVECA         "); //Constante
      fwrite($file,$datos_empleado['nacionalidad']); //Nacionalidad
			fwrite($file,str_pad($datos_empleado['codigo'], 10, "0", STR_PAD_LEFT)); //Cedula
      fwrite($file,"                                                                                                               "); //Constante

			$nombres_sin_formato = $datos_empleado['apellidos1']." ".$datos_empleado['apellidos']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1'];
			$nombres = preg_replace("/\s+/", " ", trim($nombres_sin_formato));
			fwrite($file,str_pad($nombres, 70, " ", STR_PAD_RIGHT)); //Imprime nombres con espacios hasta 60 caracteres
      fwrite($file,"\r\n"); //Nueva Linea
      $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;
  	}

			$sumaMontoTotal = 100;

    //---------------------------------------------------//
    //-------------FOOTER--------------------------------//
    fwrite($file,"06"); //Constante
    fwrite($file,"000000000000001"); //Constante
		fwrite($file,str_pad(count($cedulas), 15, "0", STR_PAD_LEFT)); //Cantidad de registros
		fwrite($file,str_pad($sumaMontoTotal, 17, "0", STR_PAD_LEFT)); //Monto total
		fwrite($file,str_pad("", 244, " ", STR_PAD_RIGHT)); //Imprime espacios

		fwrite($file,"\r\n"); //Nueva Linea
    //---------------------------------------------------//
    fclose($file);

		$directorio = "nomina.txt";

    header('Content-Description: File Transfer');
    header('Content-Disposition: attachment; filename='.$directorio);
    header('Expires: 0');
    header('Cache-Control: must-revalidate');
    header('Pragma: public');
    header('Content-Length: ' . filesize($directorio));
		//readfile($directorio);
		//unlink($directorio);



    // echo "<script>
    //     window.location.href = 'generar_txt.php?fileBank=$nombre_archivo';
    //     </script>";

		function api_upload_Folder($nombre_archivo,$contenido_codificado){
		  $curl = curl_init();
		  $url = "https://www.sapecpapi.ford.com/api/v1/files/bycountry/upload";
		  curl_setopt_array($curl, array(
		    CURLOPT_URL => 'https://www.sapecpapi.ford.com/api/v1/files/bycountry/upload',
		    CURLOPT_RETURNTRANSFER => true,
		    CURLOPT_ENCODING => '',
		    CURLOPT_MAXREDIRS => 10,
		    CURLOPT_TIMEOUT => 0,
		    CURLOPT_FOLLOWLOCATION => true,
		    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		    CURLOPT_CUSTOMREQUEST => 'POST',
		    CURLOPT_POSTFIELDS =>'{
		      "country": "VEN",
		      "fileContent": "'.$contenido_codificado.'",
		      "fileName": "'.$nombre_archivo.'"
		    }',
		    CURLOPT_HTTPHEADER => array(
		      'Authorization: Basic NDc0NjY5YjAtMzg0NS00ZGNjLWI2YWYtMzQzY2UyMGM5NWQ1OmN1Sk13dXRsVjh6NmxnTWRHYXl1Rmg3M3R4REJGdDcvckI2YTVwU1YySEk9', 'Content-Type: application/json'
		    ),
		  ));

		  $response = curl_exec($curl);
		  $result_api = json_decode($response,true);
		  //TOMAR EL ESTADO DE LA CONSULTA HTTP
		  $info = curl_getinfo($curl);
		  $error = curl_error($curl);
		  if(empty($info['http_code'])){
		    die("No HTTP code was returned");
		  }else if($info['http_code']==200){
		    $resultado_transmision = "<b>El archivo fue transmitido satisfactoriamente</b>";
		  }else if($info['http_code']>200){
		    //$http_codes = parse_ini_file($url);
		    foreach($result_api['error']['messages'] as $result) {
		      $resultado_transmision = "<b>Hubo un error al transmitir el archivo: </b><br><br>"."<b>Error: </b>".$result;
		    }
		  }
		  curl_close($curl);

		  if ($resultado_transmision==''){ //Si no obtiene respuesta, error desconocido
		    $resultado_transmision= "<b>Hubo un error al transmitir el archivo:</b> <br><br>"."<b>Error: </b>Error desconocido al transmitir la información";
		  }
		  return $resultado_transmision;
		}

		//########### Para producción:
		$contenido_codificado = base64_encode(file_get_contents($directorio));
		$nombre_archivo = "nomina.txt";

		echo "Conentido codificado: <br>".$contenido_codificado;

		//########### Para pruebas con API solo mensaje:
		// $contenido_codificado = base64_encode("hola, esto es una prueba");
		// $nombre_archivo = "andres.txt";
		//

		//$result_upload = api_upload_Folder($nombre_archivo,$contenido_codificado);


		//########### Para pruebas sin API, descargar archivo TXT:
		// echo "<style>
		// 	.regristrado{
		// 			color: green;
		// 			margin-left: 7%;
		// 			font-weight: bold;
		// 	}
		// </style>";
		// echo "<p class='regristrado'>Archivo guardado correctamente<p>";
		// echo "<script>
		// 			window.location.href = 'generar_txt.php?fileBank=$nombre_archivo';
		// 		</script>";

  }

















		else if($_POST['nomina'] == 'nomina_fideicomiso'){

        //-------------CREACIÓN DE EL ARCHIVO DE FIDEICOMISO/////////

        $tipo_nomina = "99999990";
        $fecha_tramite = end($diashabiles);
        $fecha_pagar_nomina = date('Y-m-d',strtotime($hasta."+ 4 days"));

        //Consulto los festivos existentes
        $queryFestivos = "SELECT `fecha` FROM tab_feriado";
        $resultFestivos = mysql_query($queryFestivos);
        $arrayFestivos = [];

        //Construyo array con los festivos existentes
        while($datosFestivos = mysql_fetch_array($resultFestivos)){
            $datoFestivo = date('m-d',strtotime($datosFestivos['fecha']));
            $arrayFestivos[] = $datoFestivo;
        }

        //Verifico si la fecha a pagar es festivo
        for($iFes=0;$iFes < count($arrayFestivos);$iFes++){
            $verificar_festivo = date('m-d',strtotime($fecha_pagar_nomina));
            if($verificar_festivo == $arrayFestivos[$iFes]){
                $fecha_pagar_nomina = date('Y-m-d',strtotime($fecha_pagar_nomina."- 1 days"));
                $iFes=0;
            }
        }

        //Se le quita los guiones
        $fecha_pagar_nomina_array = explode("-",$fecha_pagar_nomina);

        //Unir todos los datos para imprimir
        $fecha_pagar_nomina = $fecha_pagar_nomina_array[0]."".$fecha_pagar_nomina_array[1]."".$fecha_pagar_nomina_array[2];

        //Define la semana de este periodo
        $semanainicio = $semanainicio -1;
        //-------------------------------------------------//
        $nombre_archivo = "nomina.txt";
        $file = fopen($nombre_archivo,"w+");

        //----------------------------HEADER--------------//
        fwrite($file,"HDR");
        fwrite($file,"UNIOVECA       ED  95BPAYMULP");
        fwrite($file,"\n");
        fwrite($file,"01");
        fwrite($file,$tipo_nomina);
        fwrite($file,$n);
        fwrite($file,$year);
        fwrite($file,$type);
        fwrite($file,"0");
        fwrite($file,$semanainicio);
        fwrite($file,"9");
        fwrite($file,"  ");
        fwrite($file,$dateNow);
        fwrite($file,"APCJ000148643");
        fwrite($file,"       FORD MOTOR VENEZUELA S.A.");
        fwrite($file,"\n");
        fwrite($file,"02");
        fwrite($file,$fecha_pagar_nomina);
        fwrite($file,"0".$n);
        fwrite($file,$year);
        fwrite($file,$type);
        fwrite($file,"0");
        fwrite($file,$semanainicio);
        fwrite($file,"           6401");
        $sumaMontoTotal = 0;
        foreach ($cedulas as $c){
            //-----MONTO FIDICOMISO
            $queryF = "SELECT SUM(prestacion_monto) as monto FROM `prestaciones_fideicomiso` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH'";
            $resultadoF = mysql_query($queryF);

            while ( $sumatoriaF = mysql_fetch_array($resultadoF)) {
                $empleadoFideicomiso = $sumatoriaF['monto'];
            }

            $montoEmpleado =  $empleadoFideicomiso;
            $montoEmpleado = number_format($montoEmpleado, 2);
            $montoEmpleado =  str_replace(',','',$montoEmpleado);
            $montoEmpleado =  str_replace('.','',$montoEmpleado);
            $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;
        }
        $num_sumaMontoTotal = strlen($sumaMontoTotal);
        while($num_sumaMontoTotal<17){
            fwrite($file,"0");
            $num_sumaMontoTotal++;
        }
        fwrite($file,$sumaMontoTotal);
        fwrite($file,"VES");
        fwrite($file,"01340968419683001284               UNIOVECA");
        fwrite($file,"\n");
        $sumaMontoTotal = 0;
        // ordenar por ultimmo
        //--------------------------------------------------//
        //-------------------------BODY----------------------//
        foreach ($cedulas as $c) {
                fwrite($file,"03");
                fwrite($file,"9  ");

                //-----MONTO FIDICOMISO
                $queryF = "SELECT SUM(prestacion_monto) as monto FROM `prestaciones_fideicomiso` WHERE `cedula` LIKE '$c' AND `periodo` LIKE '$periodoDH'";
                $resultadoF = mysql_query($queryF);

                while ( $sumatoriaF = mysql_fetch_array($resultadoF)) {
                    $empleadoFideicomiso = $sumatoriaF['monto'];
                }

                $montoEmpleado =  $empleadoFideicomiso;
                $montoEmpleado =  number_format($montoEmpleado, 2);
                $montoEmpleado =  str_replace(',','',$montoEmpleado);
                $montoEmpleado =  str_replace('.','',$montoEmpleado);
                $num_montoEmpleado = strlen($montoEmpleado);
                while($num_montoEmpleado<17){
                    fwrite($file,"0");
                    $num_montoEmpleado++;
                }
                fwrite($file,$montoEmpleado);
                fwrite($file,"VES01");
                fwrite($file,$n_alterno);
                $query3 = "SELECT * FROM `personal` WHERE codigo = '$c'";
                $resultado = mysql_query($query3);
                $datos_empleado = mysql_fetch_array($resultado);
                fwrite($file,substr($datos_empleado['global_id'],-4));
                fwrite($file,"       ");
                fwrite($file,"10442    ");
                fwrite($file,$datos_empleado['cuenta']);
                fwrite($file,"               UNIOVECA         ");
                fwrite($file,$datos_empleado['nacionalidad']);
                fwrite($file,"00".$datos_empleado['codigo']);
                fwrite($file,"                                                                                                               ");
                if($datos_empleado['apellidos1'] == null){
                    fwrite($file,$datos_empleado['apellidos']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1']);
                }else{
                    fwrite($file,$datos_empleado['apellidos']." ".$datos_empleado['apellidos1']." ".$datos_empleado['nombres']." ".$datos_empleado['nombres1']);
                }
                fwrite($file,"\n");
                $sumaMontoTotal = $sumaMontoTotal + $montoEmpleado;
            }

        //---------------------------------------------------//
        //-------------FOOTER--------------------------------//
        fwrite($file,"06");
        fwrite($file,"000000000000001");
        $num_cedulas = strlen(count($cedulas));
        while($num_cedulas<15){
            fwrite($file,"0");
            $num_cedulas++;
        }
        fwrite($file,count($cedulas));
        $num_sumaMontoTotal = strlen($sumaMontoTotal);
        while($num_sumaMontoTotal<17){
            fwrite($file,"0");
            $num_sumaMontoTotal++;
        }
        fwrite($file,$sumaMontoTotal);
        //---------------------------------------------------//
        fclose($file);


        echo "<style>
        .regristrado{
            color: green;
            margin-left: 7%;
            font-weight: bold;
        }
        </style>";
        echo "<p class='regristrado'>Archivo guardado correctamente<p>";

        echo "<script>
            window.location.href = 'generar_txt.php?fileBank=$nombre_archivo';
            </script>";
    }
}


$query = "SELECT * FROM nomina";
$consulta=mysql_query($query);
$resultado=mysql_num_rows($consulta);


//--Desde - Hasta Consulta
$consultaDesdeHastaDiaria = mysql_query("SELECT `desde`,`hasta` from periodo where nomina='".$_SESSION['id_validar']."'");

// var_dump($fila);
//guardado de datos
////SCRIPTS///
?>

<head>
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script src="autocompletar/js/bootstrap3-typeahead.min.js"></script>

<link rel="stylesheet" href="css/timepicker.min.css">
<script src="js/timepicker.min.js"></script>

<link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

<script src='js/bootstrap.min.js'></script>

<!-- <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
	integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
		integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
		crossorigin="anonymous"></script> -->
<!--
<script src="//cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
<link rel="stylesheet" href="//cdn.datatables.net/1.10.25/css/jquery.dataTables.min.css"> -->



</head>
<style>
	.dropdown-menu>.active>a, .dropdown-menu>.active>a:focus, .dropdown-menu>.active>a:hover {
		color: #fff;
		text-decoration: none;
		background-color: #337ab7;
		outline: 0;
	}
	#tabla_novedades .horas_extras, .ausencia_medica, .validado_por_sso, .justificacion_ausencia, .remunerado_ausencia, .tiempo_viaje_ausencia, .ausencia, .ausencia_programada, .tipo_permiso_ausencia, .retardo, .salida_anticipada, .horassalida_anticipada, .datos_trabajador, .hora_salida_ausencia, .hora_llegada_ausencia  {
  	display: none;
	}
	#ocultar {
  	display: none;
	}

	.form-control-time {
	width: 80px;
    height: 34px;
    padding: 6px 12px;
    font-size: 12px;
    line-height: 1.42857143;
    color: #555;
    background-color: #fff;
    background-image: none;
    border: 1px solid #ccc;
    border-radius: 4px;
    -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .075);
    box-shadow: inset 0 1px 1px rgba(0, 0, 0, .075);
    -webkit-transition: border-color ease-in-out .15s, box-shadow ease-in-out .15s;
    transition: border-color ease-in-out .15s, box-shadow ease-in-out .15s;
	}
	.boton{
    /* width: 100%; */
    color: #FFFFFF;
    /* font-size: 0.8725em; */
    padding: 7px;
    margin-bottom: 5px;
    margin-top: 10px;
    outline: none;
    /* margin: 5px 0; */
    font-family: 'Open Sans', sans-serif;
    font-size: 16px;
    font-weight: bold;
    text-transform: uppercase;
    background: #36C1E2;
    border: 0px solid #DFDFDF;
	}

    .glyphicon-modal-window:before{content:"\e237"}
    .modal-open{overflow:hidden}
    .modal{position:fixed;top:0;right:0;bottom:0;left:0;z-index:1050;display:none;overflow:hidden;-webkit-overflow-scrolling:touch;outline:0}
    .modal.fade .modal-dialog{-webkit-transform:translate(0,-25%);-ms-transform:translate(0,-25%);-o-transform:translate(0,-25%);transform:translate(0,-25%);-webkit-transition:-webkit-transform .3s ease-out;-o-transition:-o-transform .3s ease-out;transition:-webkit-transform .3s ease-out;transition:transform .3s ease-out;transition:transform .3s ease-out,-webkit-transform .3s ease-out,-o-transform .3s ease-out}
    .modal.in .modal-dialog{-webkit-transform:translate(0,0);-ms-transform:translate(0,0);-o-transform:translate(0,0);transform:translate(0,0)}
    .modal-open .modal{overflow-x:hidden;overflow-y:auto}
    .modal-dialog{position:relative;width:auto;margin:10px}
    .modal-content{position:relative;background-color:#fff;background-clip:padding-box;border:1px solid #999;border:1px solid rgba(0,0,0,.2);border-radius:6px;-webkit-box-shadow:0 3px 9px rgba(0,0,0,.5);box-shadow:0 3px 9px rgba(0,0,0,.5);outline:0}
    .modal-backdrop{position:fixed;top:0;right:0;bottom:0;left:0;z-index:1040;background-color:#000}
    .modal-backdrop.fade{filter:alpha(opacity=0);opacity:0}
    .modal-backdrop.in{filter:alpha(opacity=50);opacity:.5}
    .modal-header{padding:15px;border-bottom:1px solid #e5e5e5}
    .modal-header .close{margin-top:-2px}
    .modal-title{margin:0;line-height:1.42857143}
    .modal-body{position:relative;padding:15px}
    .modal-footer{padding:15px;text-align:right;border-top:1px solid #e5e5e5}
    .modal-footer .btn+.btn{margin-bottom:0;margin-left:5px}
    .modal-footer .btn-group .btn+.btn{margin-left:-1px}
    .modal-footer .btn-block+.btn-block{margin-left:0}
    .modal-scrollbar-measure{position:absolute;top:-9999px;width:50px;height:50px;overflow:scroll}@media (min-width:768px){.modal-dialog{width:600px;margin:30px auto}
    .modal-content{-webkit-box-shadow:0 5px 15px rgba(0,0,0,.5);box-shadow:0 5px 15px rgba(0,0,0,.5)}
    .modal-sm{width:300px}}@media (min-width:992px){.modal-lg{width:900px}}
    .tooltip{position:absolute;z-index:1070;display:block;font-family:"Helvetica Neue",Helvetica,Arial,sans-serif;font-style:normal;font-weight:400;line-height:1.42857143;line-break:auto;text-align:left;text-align:start;text-decoration:none;text-shadow:none;text-transform:none;letter-spacing:normal;word-break:normal;word-spacing:normal;word-wrap:normal;white-space:normal;font-size:12px;filter:alpha(opacity=0);opacity:0}
    .tooltip.in{filter:alpha(opacity=90);opacity:.9}
</style>

<style>

/*the container must be positioned relative:*/
.autocomplete {
  position: relative;
  display: inline-block;
  text-transform: capitalize;
}
.autocompletar{
	text-transform: capitalize;
}
.regristrado{
	color: green;
	margin-left: 7%;
	font-weight: bold;
}

.noregristrado{
	color: red;
	margin-left: 7%;
	font-weight: bold;
}

.autocomplete-items {
  position: absolute;
  border: 1px solid #d4d4d4;
  border-bottom: none;
  border-top: none;
  z-index: 99;
  /*position the autocomplete items to be the same width as the container:*/
  top: 100%;
  left: 0;
  right: 0;
}

.autocomplete-items div {
  padding: 5px;
  cursor: pointer;
  background-color: #fff;
  border-bottom: 1px solid #d4d4d4;
}

/*when hovering an item:*/
.autocomplete-items div:hover {
  background-color: #e9e9e9;
}

/*when navigating through the items using the arrow keys:*/
.autocomplete-active {
  background-color: DodgerBlue !important;
  color: #ffffff;
}

#response_alert{
	background: #36C1E2;
	padding: 10px;
	width: auto;
	color: #fff;
	text-align: left;
	line-height : 25px;
}
</style>
<body>
<?php

//////////////////////////////////////////////////////////////////////////////// INICIO MENU DE OPCIONES
			echo "<main class='container'>";
			echo "<section class='row text-center'>";
			echo "<h2 class='text-dark text-left'><b>Generar bancos</b></h2>";
			// echo $_SERVER['PHP_SELF']."&codigo=".$_SESSION['codigo_cedula'];

			if ($result_upload != ""){
				echo "<div id='response_alert'>";
				echo "$result_upload";
				echo "</div>";
			}

			echo "<div class='col-sm-12 justify-content-center m-auto'>";
            echo "<form autocomplete='off' name = 'entrada' action = '".$_SERVER['PHP_SELF']."' method = 'POST'  enctype='multipart/form-data'>";
			echo "<input type = 'hidden' name = 'inicio' value = '1'>";
            echo "<div class='form-group form-inline' style='padding-top: 20px;'>";
            echo "<label name='label-novedad'>Tipo de Archivo:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:250px;' name='nomina' id='nomina' class='form-control'required>
                        <option value='' selected> Seleccione";
                        echo "<option value='nomina_normal'>Nómina a Pagar</option>";
                        echo "<option value='nomina_contingencia'>Contingencia</option>";
                        echo "<option value='nomina_fideicomiso'>Fideicomiso</option>";
                        echo "<option value='nomina_cestaticket'>Cestaticket</option>";
            echo "</select>";
            echo "</div>&nbsp;&nbsp;";
            echo "<div class='form-group form-inline'>";
            echo "<label name='label-novedad'>Tipo de Nómina:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:250px;' name='tipo_nomina' id='tipo_nomina' class='form-control'required>
                        <option value='' selected> Seleccione";
                        while($fila=mysql_fetch_array($consulta)){
                            echo "<option value='".$fila['codigo']."'>".ucwords(strtolower($fila['detalle']))."";
                        }
            echo "</select>";
            echo "</div>&nbsp;&nbsp;";
            echo "<div class='form-group form-inline'>";
            echo "<label name='label-novedad'>Período:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
                    <select style='width:250px;' name='periodo' id='periodo' class='form-control' required>
                        <option value='' selected> Seleccione";
            echo "</select>";

                echo "
            </div>&nbsp;&nbsp;";
            echo '<input name="generarBanco" type="submit" class="boton" id="enviarNomina" value="Generar reporte"></input>';
            echo "</form>";
			echo "</section>";
			echo "</main>";

	?>

  <script>
		$('#tipo_nomina').change(function() {
				var tipo_nomina = $('#tipo_nomina').val();
				var dates = new FormData();
				dates.append('tipo_nomina', tipo_nomina);
				fetch('autocompletar/consultahorario.php',{
						method: 'POST',
						body: dates
				})
				.then(res => res.json())
				.then(data => {
						if(data == 'Error'){
								console.log('error');
						}else{
						}
						if(tipo_nomina==100){
								$('#periodo').empty();
								$('#periodo').append($("<option>",{
										value: '',
										text: 'Seleccione'
								}));
								for(i=0;i<data.length;i++){
										$('#periodo').append($("<option>",{
												value:  data[i]['desde'] +' '+ data[i]['hasta'],
												text: data[i]['desde'] +'  '+ data[i]['hasta']
										}));
								}


								console.log(data[1]['desde']);
						}else if(tipo_nomina==200){
								 $('#periodo').empty();
								$('#periodo').append($("<option>",{
										value: '',
										text: 'Seleccione'
								}));
								if(data!==null){
										for(i=0;i<data.length;i++){
												$('#periodo').append($("<option>",{
														value:  data[i]['desde'] +' '+ data[i]['hasta'],
														text: data[i]['desde'] +'  '+ data[i]['hasta']
												}));
										}
										console.log(data);
								}
						}
				});
		});

    $(document).ready(function() {
        $('#enviarNomina').prop('disabled', true);
        $('#enviarNomina').css("opacity", 0.2);
        $('#nomina').change(function() {
            if($(this).val() != '' && $('#tipo_nomina').val() != '' && $('#periodo').val() != '') {
                $('#enviarNomina').prop('disabled', false);
                $('#enviarNomina').css("opacity", 1);
            }else{
                $('#enviarNomina').prop('disabled', true);
                $('#enviarNomina').css("opacity", 0.2);
            }
        });
        $('#tipo_nomina').change(function() {
            if($(this).val() != '' && $('#nomina').val() != '' && $('#periodo').val() != '') {
                $('#enviarNomina').prop('disabled', false);
                $('#enviarNomina').css("opacity", 1);
            }else{
                $('#enviarNomina').prop('disabled', true);
                $('#enviarNomina').css("opacity", 0.2);
            }
        });
        $('#periodo').change(function() {
            if($(this).val() != '' && $('#nomina').val() != '' && $('#tipo_nomina').val() != '') {
                $('#enviarNomina').prop('disabled', false);
                $('#enviarNomina').css("opacity", 1);
            }else{
                $('#enviarNomina').prop('disabled', true);
                $('#enviarNomina').css("opacity", 0.2);
            }
        });
    });
  </script>
</body>
</html>
